-- local dragData = {};
-- dragData.owner = self;
-- dragData.callBack = self.onRevieveFun;
-- dragData.dragData = "aaaa";
-- dragData.atlas = self.icon1.atlas;
-- dragData.spiteName = self.icon1.spiteName;
-- dragData.recieveItems = Array();
-- dragData.recieveItems:add(self.click_bg2);
-- dragData.recieveItems:add(self.click_bg3);
-- dragData.recieveItems:add(self.click_bg4);
-- dragData.recieveItems:add(self.click_bg5);
-- dragData.recieveItems:add(self.click_bg6);
-- dragData.recieveItems:add(self.click_bg7);
-- Lua_WindowUtil.openWin("Lua_DragAndDropWindow", WinParam.ACTION_OPEN, dragData);

Lua_DragAndDropWindow = class("Lua_DragAndDropWindow", Lua_Window);
function Lua_DragAndDropWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_DragAndDropWindow";
	self.layer = 6500;
	self.isModel = true;
	self.isClickClose = false;
	self.showClose = false;
	self.showBg = false;
	self.blackAlpha = 0.02;
	self.setHasBlackMask = false;
end

function Lua_DragAndDropWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.img = UICreate.createUIAtlasImage(self.content, "iconantlas1", "arrow_down",0,0,0,0);
	self.img:setDepth(2);
	self.img:setEnable(false);
end

function Lua_DragAndDropWindow:showWin(param)
	self.img:setAltas(param.atlas, param.spiteName);
	self.img:resetSize();

	self.recieveItems = param.recieveItems;
	self.owner = param.owner;
	self.callBack = param.callBack;
	self.noRecieveCallBack = param.noRecieveCallBack;
	self.dragData = param.dragData;

	Lua_CommonUtil.addTimer("dragAndDrop", 0.001, self, self.onImageMoving);
	self:onImageMoving();
end

function Lua_DragAndDropWindow:onImageMoving()
	if self.hasDispose5 ~= true then
		local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
		local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
		local mousePosition = self.content.transform:InverseTransformPoint(screenpos);
		self.img:setEnable(true);
		self.img:setLocation(mousePosition.x, mousePosition.y, 0);
	end
end

function Lua_DragAndDropWindow:dispose()
	local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local hasRecieve = 0;
	for i = 1, self.recieveItems:getSize() do
		if self.recieveItems[i]:checkBounds(screenpos) == true then
			self.callBack(self.owner, self.recieveItems[i], self.dragData);
			hasRecieve = 1;
			break;
		end
	end

	if hasRecieve == 0 and self.owner ~= nil and self.noRecieveCallBack ~= nil then
		self.noRecieveCallBack(self.owner, self.dragData);
	end
	self.owner = nil;
	self.callBack = nil;
	self.noRecieveCallBack = nil;
	self.hasDispose5 = true;
	Lua_CommonUtil.removeTimer(self, self.onImageMoving);

	self:superCall("dispose");
end